searchNodes=[{"doc":"Wrapper for cyrus sasl library for GSSAPI mechanism support in erlang applications. Each function (except kinit) corresponds to functions at libsasl2","ref":"sasl_auth.html","title":"sasl_auth","type":"module"},{"doc":"","ref":"sasl_auth.html#client_listmech/1","title":"sasl_auth.client_listmech/1","type":"function"},{"doc":"","ref":"sasl_auth.html#client_new/3","title":"sasl_auth.client_new/3","type":"function"},{"doc":"","ref":"sasl_auth.html#client_start/1","title":"sasl_auth.client_start/1","type":"function"},{"doc":"","ref":"sasl_auth.html#client_step/2","title":"sasl_auth.client_step/2","type":"function"},{"doc":"","ref":"sasl_auth.html#init/0","title":"sasl_auth.init/0","type":"function"},{"doc":"","ref":"sasl_auth.html#kinit/2","title":"sasl_auth.kinit/2","type":"function"},{"doc":"","ref":"sasl_auth.html#t:available_mechs/0","title":"sasl_auth.available_mechs/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:host/0","title":"sasl_auth.host/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:keytab_path/0","title":"sasl_auth.keytab_path/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:principal/0","title":"sasl_auth.principal/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:sasl_code/0","title":"sasl_auth.sasl_code/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:service_name/0","title":"sasl_auth.service_name/0","type":"type"},{"doc":"","ref":"sasl_auth.html#t:state/0","title":"sasl_auth.state/0","type":"type"},{"doc":"sasl_auth is a simple wrapper for cyrus sasl library . It helps to implement SASL GSSAPI auth mechanism support in your Erlang application.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Ubuntu On Ubuntu the following packages should be installed to build and use sasl_auth : libkrb5, libkrb5-dev, libsasl2, libsasl2-dev, libsasl2-modules-gssapi-mit. See the dockerfiles in scripts/setup_and_run_rebar3_ct_in_docker for information about which packages are needed for other Linux distributions. Redhat based distributions Redhat 7 based distribution or compatabile The following packages are required on Redhat 7 based or compatible distributions : cyrus-sasl, cyrus-sasl-devel, cyrus-sasl-gssapi, krb5-devel, and krb5-libs. Use either yum or dnf (depending on redhat base version) to install cyrus-sasl, cyrus-sasl-gssapi, and krb5-libs. yum install cyrus-sasl cyrus-sasl-devel cyrus-sasl-gssapi krb5-devel krb5-libs Redhat 8 based distributions or compatabile The following packages are required on Redhat 8 based or compatible distributions : cyrus-sasl-libs, cyrus-sasl-devel, cyrus-sasl-gssapi, krb5-devel, and krb5-libs. dnf install cyrus-sasl-libs cyrus-sasl-devel cyrus-sasl-gssapi krb5-devel krb5-libs Mac OS Install cyrus-sasl via homebrew, this includes the gssapi module, as well MIT krb5 as a dependency : brew install cyrus-sasl","ref":"readme.html#dependencies","title":"Overview - Dependencies","type":"extras"},{"doc":"$ rebar3 compile","ref":"readme.html#build","title":"Overview - Build","type":"extras"},{"doc":"You can execute the tests with the following command (if you have Docker installed): $ `./scripts/setup_and_run_rebar3_ct_in_docker.sh` By default, the script above runs the test in a docker container that is created from a docker image that is described in the file scripts/setup_and_run_rebar3_ct_in_docker/Dockerfile.ubuntu22.04 . You can change the dockerfile by specifying the environment variable SASL_AUTH_DOCKER_FILE . The following command will run the tests in a Centos7 docker image: $ `SASL_AUTH_DOCKER_FILE=scripts/setup_and_run_rebar3_ct_in_docker/Dockerfile.centos7 ./scripts/setup_and_run_rebar3_ct_in_docker.sh` You can execute the following command to run the tests in a docker container with Erlang/OTP and the NIF library compiled with address sanitizer (finds memory errors and leaks): $ `./scripts/setup_and_run_rebar3_ct_in_docker.sh` asan It is a little bit more complicated to run the tests without Docker and the exact steps may depend on the operating system you are using. The following steps outlines what needs to be done: Install necessary packages The dockerfile scripts/setup_and_run_rebar3_ct_in_docker/Dockerfile.ubuntu22.04 contains information about which packages need to be installed in Ubuntu. Configure a Kerberos server and create a keytab for a user This can be done by following the steps in scripts/setup_and_run_rebar3_ct_in_docker/setup_and_run.sh until the command echo RUN TESTS . Export and set the following environment variables to appropriate values: export SASL_AUTH_TEST_HOST = example . com # Host that Kerberos is running on export SASL_AUTH_TEST_PRINCIPAL = user # A user name export SASL_AUTH_TEST_KEY_TAB = user . keytab # Keytab for user Run the tests: rebar3 ct","ref":"readme.html#test","title":"Overview - Test","type":"extras"},{"doc":"sasl_auth is used in brod_gssapi (a GSSAPI authentication backend for the Apache Kafka client library for Erlang/Elixir brod . See usage details in the README file for brod_gssapi .","ref":"readme.html#use","title":"Overview - Use","type":"extras"},{"doc":"Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html","title":"License","type":"extras"},{"doc":"&quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.","ref":"license.html#1-definitions","title":"License - 1. Definitions.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license","title":"License - 2. Grant of Copyright License.","type":"extras"},{"doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license","title":"License - 3. Grant of Patent License.","type":"extras"},{"doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: You must give any other recipients of the Work or Derivative Works a copy of this License; and You must cause any modified files to carry prominent notices stating that You changed the files; and You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.","ref":"license.html#4-redistribution","title":"License - 4. Redistribution.","type":"extras"},{"doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.","ref":"license.html#5-submission-of-contributions","title":"License - 5. Submission of Contributions.","type":"extras"},{"doc":"This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.","ref":"license.html#6-trademarks","title":"License - 6. Trademarks.","type":"extras"},{"doc":"Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON- INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.","ref":"license.html#7-disclaimer-of-warranty","title":"License - 7. Disclaimer of Warranty.","type":"extras"},{"doc":"In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability","title":"License - 8. Limitation of Liability.","type":"extras"},{"doc":"While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html#9-accepting-warranty-or-additional-liability","title":"License - 9. Accepting Warranty or Additional Liability.","type":"extras"}]